=== debian/changelog ===
fastcdr (2.2.6+really2.2.5-1ubuntu1) questing; urgency=medium

  * d/libfastcdr2.symbols: mark symbols as optional to fix FTBFS in ppc64el.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 04 May 2025 17:24:19 +0100

fastcdr (2.2.6+really2.2.5-1) unstable; urgency=medium

  * Revert to previous patch release due to unexpected ABI break.

 -- Timo Röhling <roehling@debian.org>  Thu, 27 Feb 2025 12:00:04 +0100

fastcdr (2.2.6-1) unstable; urgency=medium

  * New upstream version 2.2.6
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.1
  * Wrap and sort Debian package files
  * Add new symbols

 -- Timo Röhling <roehling@debian.org>  Wed, 26 Feb 2025 15:30:23 +0100
