=== debian/control ===
Source: fastcdr
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
Uploaders:
 Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 doxygen <!nodoc>,
 graphviz <!nodoc>,
 libgtest-dev <!nocheck>,
 ninja-build,
 pkg-kde-tools,
Standards-Version: 4.7.1
Rules-Requires-Root: no
Homepage: https://github.com/eProsima/Fast-CDR
Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
Vcs-Browser: https://salsa.debian.org/robotics-team/fastcdr
Description: Fast CDR serialization library for DDS
 eProsima FastCDR is a C++ library that provides serialization and
 deserialization according to the Common Data Representation (CDR) of the Data
 Distribution Service (DDS) standard and is part of the eProsima FastDDS
 implementation.

Package: libfastcdr2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}

Package: libfastcdr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libfastcdr2 (= ${binary:Version}),
 ${misc:Depends},
Description: ${source:Synopsis} - development headers
 ${source:Extended-Description}
 .
 This package installs the development headers.

Package: libfastcdr-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Description: ${source:Synopsis} - API documentation
 ${source:Extended-Description}
 .
 This package installs the API documentation.
