=== debian/changelog ===
fastcdr (2.3.1-2) unstable; urgency=medium

  * Fix architecture-specific symbol substitutions
  * Migrate debian/watch to version 5 format

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 13:08:51 +0200

fastcdr (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1
  * Update patches.
    Obsolete: 0002-Fix-visibility-of-exception-classes.patch
  * Bump Standards-Version to 4.7.2
  * Update symbols

 -- Timo Röhling <roehling@debian.org>  Mon, 22 Sep 2025 11:57:42 +0200
