=== debian/changelog ===
fastcdr (2.3.2-1) unstable; urgency=medium

  * New upstream version 2.3.2
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 30 Sep 2025 16:05:13 +0200
