=== debian/changelog ===
fastcdr (2.3.3-1) unstable; urgency=medium

  * New upstream version 2.3.3
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 17 Oct 2025 22:22:59 +0200
