=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: fastcdr
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
+Maintainer: Debian Robotics Team <team+robotics@tracker.debian.org>
 Uploaders:
  Timo Röhling <roehling@debian.org>,
 Build-Depends:
@@ -14,7 +13,7 @@
  libgtest-dev <!nocheck>,
  ninja-build,
  pkg-kde-tools,
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/eProsima/Fast-CDR
 Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
