=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all future=+lfs

include /usr/share/dpkg/architecture.mk

BUILD_TESTING = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),OFF,ON)
BUILD_DOCS = $(if $(filter nodoc,$(DEB_BUILD_OPTIONS)),OFF,ON)

%:
	dh $@ --buildsystem=cmake+ninja --with pkgkde_symbolshelper

override_dh_autoreconf:

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake+ninja -- \
		-DBUILD_TESTING=$(BUILD_TESTING) \
		-DBUILD_DOCUMENTATION=$(BUILD_DOCS) \
		-DCMAKE_CXX_FLAGS_NONE="-fvisibility=hidden -fvisibility-inlines-hidden" \
		-DLIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	rm debian/tmp/usr/share/fastcdr/LICENSE
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/fastcdr
	mv debian/tmp/usr/include/fastcdr/config.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/fastcdr/config.h

execute_after_dh_installdocs-indep:
	ln -sf /usr/share/javascript/jquery/jquery.min.js debian/libfastcdr-doc/usr/share/doc/libfastcdr-dev/api_reference/jquery.js
