=== debian/watch ===
Version: 5

Template: Github
Owner: eProsima
Project: Fast-CDR
Uversion-Mangle: auto
