=== src/cpp/CMakeLists.txt ===
--- 
+++ 
@@ -148,12 +148,15 @@
     if(PDB_FILE)
         get_target_property(PDB_DIR ${PROJECT_NAME} PDB_OUTPUT_DIRECTORY_DEBUG)
         set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
-    elseif(NOT CMAKE_CXX_COMPILER_LAUNCHER STREQUAL "ccache")
+    else()
         # fallback to static lib symbols
-        get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
-        if(PDB_FILE)
-            get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
-            set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
+        get_target_property(MSVC_DEBUG_INFORMATION_FORMAT ${PROJECT_NAME} MSVC_DEBUG_INFORMATION_FORMAT)
+        if(NOT MSVC_DEBUG_INFORMATION_FORMAT MATCHES ".*Embedded.*")
+            get_target_property(PDB_FILE ${PROJECT_NAME} COMPILE_PDB_NAME_DEBUG)
+            if(PDB_FILE)
+                get_target_property(PDB_DIR ${PROJECT_NAME} COMPILE_PDB_OUTPUT_DIRECTORY_DEBUG)
+                set(PDB_FILE "${PDB_DIR}/${PDB_FILE}.pdb")
+            endif()
         endif()
     endif()
