=== debian/changelog ===
fastcdr (2.3.4-1) unstable; urgency=medium

  * New upstream version 2.3.4
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Nov 2025 20:31:11 +0100
