=== debian/changelog ===
fastcdr (2.3.5-1) unstable; urgency=medium

  * New upstream version 2.3.5
  * Refresh patches (no functional changes)
  * Bump Standards-Version to 4.7.3

 -- Timo Röhling <roehling@debian.org>  Sat, 07 Feb 2026 18:29:52 +0100
