=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
  libgtest-dev <!nocheck>,
  ninja-build,
  pkg-kde-tools,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Homepage: https://github.com/eProsima/Fast-CDR
 Vcs-Git: https://salsa.debian.org/robotics-team/fastcdr.git
